package login

import (
	"net/http"
	"ddpf/response"
	"github.com/tangs-drm/go-tool/log"
	"github.com/tangs-drm/go-tool/util"
	"ddpf/model/user"
)

func Login(w http.ResponseWriter, r *http.Request) {
	var code int
	var err error
	var msg string
	var data util.Map
	defer func() {
		response.WriteResponse(w, code, msg, err, data)
	}()
	username := r.PostFormValue("username")
	password := r.PostFormValue("password")

	if len(username) < 1 || len(password) < 1 {
		err = util.Error("username/password contain a empty value")
		log.Error("Login receive invalid username/password ->(%v)", err)
		code = 1
		msg = "用户名/密码为空"
		return
	}

	// check user if exists
	var isExist bool
	isExist, err = user.ExistUser(username)
	if err != nil {
		log.Error("Login receive username(%v) ExistUser error ->(%v)", username, err)
		code = 2
		msg = "系统错误"
		return
	}
	if !isExist {
		log.Debug("Login receive username(%v) is not exist", username)
		code = 3
		msg = "用户不存在"
		return
	}

	// check user password
	var usr *user.User
	usr, err = user.CheckPassword(username, password)
	if err != nil {
		log.Error("Login receive username(%v) check password error ->(%v)", username, err)
		code = 4
		msg = "系统错误"
		return
	}
	if nil == usr {
		log.Debug("Login receive username(%v) password is incorrect", username)
		code = 5
		msg = "密码错误"
		return
	}

	// 写cookie
	//session.CreateSession()
}